/**
   SocketAttach.java

   Copyright (C) 2001, RTFM, Inc.
   All Rights Reserved.

   ekr@rtfm.com  Tue Jan  2 08:35:53 2001
*/


package COM.claymoresystems.ptls.test;

import COM.claymoresystems.cert.*;
import COM.claymoresystems.ptls.*;
import COM.claymoresystems.sslg.*;
import java.io.*;
import java.net.*;

class SocketAttach {
     public static void main(String []args) throws Exception {
       SSLContext ctx=CommonTest.makeContext();
       Socket sock=new Socket("localhost",4433);
       SSLSocket s=new SSLSocket(ctx,sock.getInputStream(),
         sock.getOutputStream(),"XXX",555,SSLSocket.CLIENT);

       try {
	 byte buf[]=new byte[4096];

	 InputStreamReader ir=new InputStreamReader(s.getInputStream());
	 BufferedReader br=new BufferedReader(ir);
	 
	 OutputStreamWriter or=new OutputStreamWriter(s.getOutputStream());
	 BufferedWriter bw=new BufferedWriter(or);

	 bw.write("GET / HTTP/1.0\r\n");
	 bw.write("User-Agent: PureTLS Client demo program\r\n");
	 bw.write("\r\n\r\n");
	 bw.flush();

	 for(;;){
	   try {
	     String str=br.readLine();
	     if(str==null)
	       break;
	     System.out.println(str);
	   } catch (SSLReHandshakeException e){
	     System.out.println("Renegotiate requested. Renegotiating");
	     s.renegotiate();
	   }
         }

         s.close();
       }
       catch (SSLAlertException e){
	 e.printStackTrace();
	 throw new Error(e.toString());
       }
     } 
}
