#!/usr/local/bin/perl5
require 'openssl.pl';

sub openssl_compat {
  printf("OpenSSL compatibility tests\n");
  # First test us as a server with OpenSSL as the client
  &loadDSSKeys;
  &execute_server($ROOT,$CIPHER,$SERVER,1,$ADDITIONAL);
  $cli_err=&openssl_execute_client;
  $ser_err=&cleanup_server;

  die("Server error: $ser_err") if $ser_err;
  die("Client error: $cli_err") if $cli_err;

  &loadRSAKeys;
  &execute_server($ROOT,$CIPHER,$SERVER,1,$ADDITIONAL);
  $cli_err=&openssl_execute_client;
  $ser_err=&cleanup_server;
  die("Server error: $ser_err") if $ser_err;

  die("Client error: $cli_err") if $cli_err;

  # Now as a client against an OpenSSL server
  &openssl_execute_server(0);
  $cli_err=&execute_client($ROOT,$CIPHER,$CLIENT,1,"XXX","-u");
  $ser_err=&openssl_cleanup_server;
  die("Server error: $ser_err") if $ser_err;
  die("Failed to detect server lack of close_notify") unless $cli_err;
  die("Client error: $cli_err") unless $cli_err=~/Short read/;

  # Now with client auth
  &openssl_execute_server(1);
  $cli_err=&execute_client($ROOT,$CIPHER,$CLIENT,1,"XXX","-u");
  $ser_err=&openssl_cleanup_server;
  die("Server error: $ser_err") if $ser_err;
  die("Failed to detect server lack of close_notify") unless $cli_err;
  die("Client error: $cli_err") unless $cli_err=~/Short read/;
}

1;# require fodder
